// Generated by CoffeeScript 1.9.2
(function() {
  var Build, Promise, Screenshot, TunnelManager, dns, ip, url;

  Screenshot = require('./Screenshot');

  TunnelManager = require('./TunnelManager');

  Promise = require('bluebird');

  dns = require('dns');

  ip = require('ip');

  url = require('url');

  Build = (function() {
    function Build(project, number) {
      var Project, ref;
      Project = require('./Project');
      if (typeof project === 'object' && !(project instanceof Project)) {
        ref = project, project = ref.project, number = ref.number;
      }
      this.project = project;
      this.number = number;
    }

    Build.prototype.get = function() {
      return this.rpc('GET', '').then((function(_this) {
        return function(build) {
          var i, len, ref, slug;
          ref = build.screenshots;
          for (i = 0, len = ref.length; i < len; i++) {
            slug = ref[i];
            build.screenshots = new Screenshot(_this, slug);
          }
          return build;
        };
      })(this));
    };

    Build.prototype.set = function(meta) {
      return this.rpc('PUT', '', {
        'meta': meta
      });
    };

    Build.prototype.remove = function() {
      return this.rpc('DELETE', '');
    };

    Build.prototype.capture = function(targetUrl, slug, meta, versions, delay) {
      var actualSlug, pieces, ref, ref1;
      if (typeof targetUrl === 'object' && !(targetUrl instanceof String)) {
        ref = targetUrl, targetUrl = ref.targetUrl, slug = ref.slug, meta = ref.meta, versions = ref.versions, delay = ref.delay;
      }
      if (typeof versions === 'undefined') {
        versions = this.project.defaults.versions;
      }
      if (typeof delay === 'undefined') {
        delay = this.project.defaults.delay;
      }
      pieces = url.parse(targetUrl);
      if ((ref1 = pieces.protocol) !== 'http:' && ref1 !== 'https:') {
        throw new Error('Only http(s) supported');
      }
      actualSlug = Promise.fromNode(function(next) {
        return dns.lookup(pieces.hostname, next);
      }).spread(function(address, family) {
        if (ip.isPrivate(address)) {
          if (!pieces.port) {
            if (pieces.protocol === 'http:') {
              pieces.port = 80;
            } else {
              pieces.port = 443;
            }
          }
          return TunnelManager.open(pieces.hostname, pieces.port).then(function(tunnel) {
            var i, key, len, ref2, tunnelPieces;
            tunnelPieces = url.parse(tunnel);
            ref2 = ['protocol', 'host', 'port', 'hostname'];
            for (i = 0, len = ref2.length; i < len; i++) {
              key = ref2[i];
              pieces[key] = tunnelPieces[key];
            }
            return url.format(pieces);
          });
        } else {
          return targetUrl;
        }
      }).then((function(_this) {
        return function(target) {
          var data;
          data = {
            'slug': slug,
            'target': target,
            'meta': meta,
            'versions': versions,
            'delay': delay
          };
          return _this.rpc('POST', '', data);
        };
      })(this))["finally"](function() {
        return TunnelManager.close(pieces.hostname, pieces.port);
      });
      return Screenshot(this.project, this, actualSlug);
    };

    Build.prototype.rpc = function(method, endpoint, body) {
      return Promise.resolve(this.number).then((function(_this) {
        return function(number) {
          return _this.project.rpc(method, "/" + number + endpoint, body);
        };
      })(this));
    };

    return Build;

  })();

  module.exports = Build;

}).call(this);
