// Generated by CoffeeScript 1.9.2
(function() {
  var Connection, KeplerError, Promise, request;

  KeplerError = require('./Error');

  Promise = require('bluebird');

  request = require('request');

  Connection = (function() {
    function Connection(apiUrl, maxSockets, socketTimeout) {
      var ref;
      if (typeof apiUrl === 'object' && !(apiUrl instanceof String)) {
        ref = apiUrl, apiUrl = ref.apiUrl, maxSockets = ref.maxSockets, socketTimeout = ref.socketTimeout;
      }
      this.url = apiUrl;
      this.pool = {
        'maxSockets': maxSockets || 5
      };
      this.timeout = socketTimeout || 20000;
    }

    Connection.prototype.rpc = function(method, endpoint, body, key) {
      if (key == null) {
        key = null;
      }
      return new Promise((function(_this) {
        return function(resolve, reject) {
          var options;
          options = {
            'url': _this.url + "/api" + endpoint,
            'method': method,
            'body': body,
            'json': true,
            'gzip': true,
            'pool': _this.pool,
            'timeout': _this.timeout
          };
          if (key != null) {
            options['headers'] = {
              'X-API-Key': key
            };
          }
          return request(options, function(err, res, body) {
            if (err) {
              return reject(err);
            }
            if (body.code !== 'OK') {
              err = new KeplerError(body.code, body.message, body.data);
              return reject(err);
            }
            return resolve(body.data);
          });
        };
      })(this));
    };

    return Connection;

  })();

  module.exports = Connection;

}).call(this);
