// Generated by CoffeeScript 1.9.2
(function() {
  var Build, Connection, Project;

  Build = require('./Build');

  Connection = require('./Connection');

  Project = (function() {
    function Project(connection, projectSlug, apiKey, screenshotDefaults) {
      var ref;
      if (typeof connection === 'object' && !(connection instanceof Connection)) {
        ref = connection, connection = ref.connection, projectSlug = ref.projectSlug, apiKey = ref.apiKey, screenshotDefaults = ref.screenshotDefaults;
      }
      this.connection = connection;
      this.slug = projectSlug;
      this.apiKey = apiKey;
      this.defaults = screenshotDefaults || {
        'versions': [{}],
        'delay': 0
      };
    }

    Project.prototype.get = function() {
      return this.rpc('GET', '').then((function(_this) {
        return function(project) {
          var i, len, number, ref;
          project.head = new Build(_this, project.head);
          ref = project.builds;
          for (i = 0, len = ref.length; i < len; i++) {
            number = ref[i];
            project.builds = new Build(_this, number);
          }
          delete project.screenshots;
          return project;
        };
      })(this));
    };

    Project.prototype.set = function(name, meta) {
      var ref;
      if (typeof name === 'object' && !name instanceof String) {
        ref = name, name = ref.name, meta = ref.meta;
      }
      return this.rpc('PUT', '', {
        'name': name,
        'meta': meta
      });
    };

    Project.prototype.remove = function() {
      return this.rpc('DELETE', '');
    };

    Project.prototype.build = function(meta) {
      var number;
      number = this.rpc('POST', '', {
        'meta': meta
      });
      return new Build(this, number);
    };

    Project.prototype.rpc = function(method, endpoint, body) {
      return this.connection.rpc(method, "/projects/" + this.slug + endpoint, body, this.apiKey);
    };

    return Project;

  })();

  module.exports = Project;

}).call(this);
