// Generated by CoffeeScript 1.9.2
(function() {
  var LINGER_DURATION, Promise, TunnelManager, localtunnel, url;

  Promise = require('bluebird');

  localtunnel = require('localtunnel');

  url = require('url');

  LINGER_DURATION = 1000;

  TunnelManager = (function() {
    function TunnelManager() {}

    TunnelManager.tunnels = {};

    TunnelManager.translations = {};

    TunnelManager.open = function(hostname, port) {
      var hash;
      hash = hostname + ":" + port;
      if (this.translations[hash]) {
        hash = this.translations[hash];
      }
      if (this.tunnels[hash]) {
        this._acquire(hash);
        return Promise.resolve(this.tunnels[hash].url);
      } else {
        return Promise.fromNode(function(next) {
          return localtunnel(port, {
            'local_host': hostname
          }, next);
        }).then((function(_this) {
          return function(tunnel) {
            var pieces, remoteHash;
            pieces = url.parse(tunnel.url);
            remoteHash = pieces.hostname + ":" + pieces.port;
            _this.translations[remoteHash] = hash;
            _this.tunnels[hash] = tunnel;
            tunnel.on('close', function() {
              delete _this.translations[remoteHash];
              return delete _this.tunnels[hash];
            });
            _this._acquire(hash);
            return tunnel.url;
          };
        })(this));
      }
    };

    TunnelManager.close = function(hostname, port) {
      var hash;
      hash = hostname + ":" + port;
      if (this.translations[hash]) {
        hash = this.translations[hash];
      }
      if (this.tunnels[hash]) {
        return this._release(hash);
      }
    };

    TunnelManager.references = {};

    TunnelManager.timers = {};

    TunnelManager._acquire = function(hash) {
      this.references[hash] = (this.references[hash] || 0) + 1;
      if (this.timers[hash]) {
        clearTimeout(this.timers[hash]);
        return delete this.timers[hash];
      }
    };

    TunnelManager._release = function(hash) {
      if (!this.references[hash]) {
        return;
      }
      this.references[hash] -= 1;
      if (this.references[hash] === 0) {
        delete this.references[hash];
        return this.timers[hash] = setTimeout((function(_this) {
          return function() {
            _this.tunnels[hash].close();
            delete _this.tunnels[hash];
            return delete _this.timers[hash];
          };
        })(this), LINGER_DURATION);
      }
    };

    return TunnelManager;

  })();

  module.exports = TunnelManager;

}).call(this);
